 -----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 0: PAYEH package                            --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- package
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

package payeh  is           
  -- The word and byte type
  --type word is array(15 downto 0) of std_logic;
  --type byte is array(7 downto 0) of std_logic; 
  subtype word is std_logic_vector(15 downto 0);
  subtype byte is std_logic_vector(7 downto 0);
  type word_vector is array (natural range <>) of word;
  
  function bin2int (bin: std_logic_vector) return integer;  
  function int2bin16 (int: integer) return std_logic_vector;
  function int2bin17 (int: integer) return std_logic_vector;  

end payeh;
-------------------------------------------------
package body payeh is  
  function bin2int (bin: std_logic_vector) return integer is
  variable int: integer := 0;
  begin
    for i in bin'high downto bin'low loop
      if bin(i)='1' then int := 2*int + 1; else int := 2*int; end if;
    end loop;
    return int;
  end bin2int;
  
  function int2bin16 (int: integer) return std_logic_vector is
  variable bin: std_logic_vector(15 downto 0) := (others=>'0');
  variable num: integer := int;
  begin
    for i in 0 to 15 loop
      if num mod 2 = 1 then bin(i):='1'; else bin(i):='0'; end if;
      num := num/2; 
    end loop;
    return bin;
  end int2bin16;
  
  function int2bin17 (int: integer) return std_logic_vector is
  variable bin: std_logic_vector(16 downto 0) := (others=>'0');
  variable num: integer := int;
  begin
    for i in 0 to 16 loop
      if num mod 2 = 1 then bin(i):='1'; else bin(i):='0'; end if;
      num := num/2; 
    end loop;
    return bin;
  end int2bin17;
end payeh;  
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 1: mux_2_1                                  --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- mux_2_1
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
-------------------------------------------------
entity mux_2_1 is
  port    (d0, d1: in  std_logic_vector; 
           sel:    in  std_logic; 
           q:      out std_logic_vector);
end mux_2_1;
-------------------------------------------------
architecture behavioral of mux_2_1 is
begin
  with sel select
    q (d0'range) <= 
       d0 when '0',
       d1 when '1',
       (others=>'Z') when others;

end behavioral;
-------------------------------------------------
-- mux_2_1 test bench:
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
-------------------------------------------------
entity mux_2_1_test is
end mux_2_1_test;
-------------------------------------------------
architecture test_bench of mux_2_1_test is

component mux_2_1
  port    (d0, d1: in  std_logic_vector; 
           sel:    in  std_logic; 
           q:      out std_logic_vector);
end component;

for all: mux_2_1 use entity work.mux_2_1(behavioral);

-- signal declaration
signal d0, d1: std_logic_vector(15 downto 0); 
signal sel: std_logic; 
signal q: std_logic_vector(15 downto 0);

begin
mux: mux_2_1 port map (d0, d1, sel, q);

d0 <= 
    "0101010111110000",
    "1111000001010101" after 250 ns; 
d1 <= 
    "0000000000000000",
    "1111111111111111" after 500 ns; 
sel<= 
    '0',  
    '1' after  100 ns,  
    'Z' after  200 ns,  
    '1' after  300 ns,  
    '0' after  400 ns,  
    '0' after  600 ns,  
    '1' after  700 ns,
    'X' after  750 ns,
    '0' after  800 ns;
end test_bench;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 2: mux_4_1                                  --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- mux_4_1
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
-------------------------------------------------
entity mux_4_1 is
  port    (d0, d1, d2, d3: in  std_logic_vector; 
           sel:    in  std_logic_vector(1 downto 0); 
           q:      out std_logic_vector);
end mux_4_1;
-------------------------------------------------
architecture behavioral of mux_4_1 is
begin
  with sel select
    q(d0'range) <= 
       d0 when "00",
       d1 when "01",
       d2 when "10",
       d3 when "11",
       (others=>'Z') when others;

end behavioral;
-------------------------------------------------
-- mux_4_1 test bench:
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
-------------------------------------------------
entity mux_4_1_test is
end mux_4_1_test;
-------------------------------------------------
architecture test_bench of mux_4_1_test is

component mux_4_1
  port    (d0, d1, d2, d3: in  std_logic_vector; 
           sel:    in  std_logic_vector(1 downto 0); 
           q:      out std_logic_vector);
end component;

for all: mux_4_1 use entity work.mux_4_1(behavioral);

-- signal declaration
signal d0, d1, d2, d3: std_logic_vector(15 downto 0); 
signal sel: std_logic_vector(1 downto 0); 
signal q: std_logic_vector(15 downto 0);

begin
mux: mux_4_1 port map (d0, d1, d2, d3, sel, q);

d0 <= 
    "0101010111110000",
    "1111000001010101" after 350 ns; 
d1 <= 
    "0000000000000000",
    "1111111111111111" after 1000 ns; 
d2 <= 
    "0011001100110011",
    "1111111100000000" after 150 ns; 
d3 <= 
    "0000000011111110",
    "1000100010001000" after 600 ns; 
sel<= 
    "00",  
    "01" after  50 ns,  
    "10" after  100 ns,  
    "11" after  150 ns,  
    "00" after  200 ns,  
    "01" after  250 ns,  
    "10" after  300 ns,  
    "11" after  350 ns,  
    "Z1" after  400 ns,  
    "X1" after  450 ns,  
    "00" after  500 ns,  
    "01" after  550 ns,  
    "10" after  600 ns,  
    "11" after  650 ns,  
    "00" after  700 ns,  
    "01" after  750 ns,  
    "10" after  800 ns,  
    "11" after  850 ns,  
    "00" after  900 ns,  
    "01" after  950 ns,  
    "10" after  1000 ns,  
    "11" after  1050 ns,  
    "10" after  1100 ns,
    "00" after  1150 ns,  
    "ZX" after  1200 ns,
    "01" after  1250 ns,  
    "10" after  1300 ns,  
    "11" after  1350 ns;  
    
end test_bench;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 3: mux4_1                                   --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- mux4_1
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
-------------------------------------------------
entity mux4_1 is
  port    (d0, d1, d2, d3: in  std_logic; 
           sel:    in  std_logic_vector(1 downto 0); 
           q:      out std_logic);
end mux4_1;
-------------------------------------------------
architecture behavioral of mux4_1 is
begin
  with sel select
    q <= 
       d0 when "00",
       d1 when "01",
       d2 when "10",
       d3 when "11",
       'Z' when others;

end behavioral;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 4: reg                                      --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- reg
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity reg is
  port    (clk, reset, wrt: in std_logic;
           d: in  std_logic_vector; 
           q: out std_logic_vector);
end reg;
-------------------------------------------------
architecture behavioral of reg is
begin
  process (clk, reset)
  begin
    if reset='1' 
    then q(d'range) <= (others=>'0'); 
    else if (clk='1' and clk'event) 
         then if wrt='1' then q <= d; end if; 
         end if;
    end if;
  end process;
end behavioral;
-------------------------------------------------
-- reg test bench:
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
-------------------------------------------------
entity reg_test is
end reg_test;
-------------------------------------------------
architecture test_bench of reg_test is

component reg
  port    (clk, reset, wrt: in std_logic;
           d: in  std_logic_vector; 
           q: out std_logic_vector);
end component;

for all: reg use entity work.reg(behavioral);

-- signal declaration
signal clk, reset, wrt: std_logic; 
signal d: std_logic_vector(15 downto 0); 
signal q: std_logic_vector(15 downto 0);

begin
r: reg port map (clk, reset, wrt, d, q);

process 
begin
  clk <= 
    '0' after 50 ns, 
    '1' after 100 ns;
  wait for 100 ns;
  if now>1 us then wait; end if; 
end process;

reset <= 
    '1',
    '0' after 100 ns,
    '1' after 1000 ns;

wrt <= '1';    
    
d <= 
    "0101010111110000",
    "1110111011101110" after 150 ns,
    "1111000001010101" after 250 ns,
    "0000000000000000" after 350 ns,
    "1111111111111111" after 450 ns; 
    
end test_bench;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 5: regfile                                  --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- register file
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity regfile is
  port    (clk, reset, write_en: in std_logic;
           read_wp, write_wp: in std_logic_vector(5 downto 0);
           read_adr1, read_adr2, write_adr: in  std_logic_vector(1 downto 0); 
           write_data: in word;
           read_data1, read_data2: out word);
end regfile;
-------------------------------------------------
architecture behavioral of regfile is
signal reg: word_vector (0 to 63) := (others => (others => '0'));
signal read_index1, read_index2, write_index: integer;
begin
  read_index1 <= bin2int (read_wp ) + bin2int (read_adr1);
  read_index2 <= bin2int (read_wp ) + bin2int (read_adr2);
  write_index <= bin2int (write_wp) + bin2int (write_adr);
  
  read_data1 <= reg(read_index1 mod 64); 
  read_data2 <= reg(read_index2 mod 64); 
  
  process (clk, reset)
  begin
    if (reset = '1') then
      reg <= (others => (others => '0'));
    elsif (clk='1' and clk'event) then
      if write_en = '1' then 
        reg(write_index mod 64) <= write_data;
      end if;
    end if;
  end process;
end behavioral;
-------------------------------------------------
-- register file test bench:
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity regfile_test is
end regfile_test;
-------------------------------------------------
architecture test_bench of regfile_test is

component regfile
  port    (clk, reset, write_en: in std_logic;
           read_wp, write_wp: in std_logic_vector(5 downto 0);
           read_adr1, read_adr2, write_adr: in  std_logic_vector(1 downto 0); 
           write_data: in word;
           read_data1, read_data2: out word);
end component;

for all: regfile use entity work.regfile(behavioral);

-- signal declaration
signal clk, reset, write_en: std_logic;
signal read_wp, write_wp: std_logic_vector(5 downto 0);
signal read_adr1, read_adr2, write_adr: std_logic_vector(1 downto 0); 
signal write_data: word;
signal read_data1, read_data2: word;

begin
r: regfile port map (clk, reset, write_en,
                     read_wp, write_wp,
                     read_adr1, read_adr2, write_adr,
                     write_data,
                     read_data1, read_data2);

process 
begin
  clk <= 
    '0' after 50 ns, 
    '1' after 100 ns;
  wait for 100 ns;
  if now>2 us then wait; end if; 
end process;

reset <= '1', '0' after 100 ns;
  
write_en <= 
    '1',
    '0' after 350 ns;
    
write_wp <=
    "000101";
    
write_adr <= 
    "01",
    "10" after 150 ns,
    "11" after 250 ns;

write_data <=
    "0000000000001111",
    "0000000011110000" after 100 ns,
    "1111000011110000" after 200 ns;
    
read_wp <= 
    "000110";
    
read_adr1 <= 
    "01",
    "00" after 400 ns,
    "10" after 500 ns;

read_adr2 <= 
    "00",
    "01" after 400 ns,
    "11" after 500 ns;

end test_bench;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 6: Incrementer                              --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- inc
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.payeh.all;

entity inc is
  port (a: in word; 
        a_plus_1: out word);
end inc;
-------------------------------------------------
architecture dataflow of inc is
begin
  a_plus_1 <= a + "0000000000000001";
end dataflow;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 7: Adder                                    --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- adder
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.payeh.all;

entity adder is
  port (a, b: in word; 
        a_plus_b: out word);
end adder;
-------------------------------------------------
architecture behavioral of adder is
begin 
  a_plus_b <= a + b;
end behavioral;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 8: ALU                                      --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- alu
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use work.payeh.all;

entity alu is
  port (a, b: in word; 
        cin : in std_logic;
        sel : in std_logic_vector(3 downto 0);
        aluout: out word;
        zout, cout: out std_logic);
end alu;
-------------------------------------------------
architecture behavioral of alu is
signal result: std_logic_vector(16 downto 0);
signal c: std_logic_vector(15 downto 0);
signal shift: integer;

signal result_bit: bit_vector(16 downto 0);
signal a_bit, b_bit: bit_vector(15 downto 0);
signal c_bit: bit;

begin 
  c <= "0000000000000001" when cin = '1' else "0000000000000000";
  shift <= bin2int(b(3 downto 0));

  process (a, b, cin, sel, result, c, shift, result_bit, a_bit, b_bit, c_bit)
--  variable result_bit: bit_vector(16 downto 0);
--  variable a_bit, b_bit: bit_vector(15 downto 0);
--  variable c_bit: bit;
  begin
  
    for i in 0 to 15 loop
      if a(i) = '1' 
      then a_bit(i) <= '1'; 
      else a_bit(i) <= '0';
      end if;

      if b(i) = '1' 
      then b_bit(i) <= '1'; 
      else b_bit(i) <= '0';
      end if;
    end loop;
    
    if cin = '1' then c_bit <= '1'; else c_bit <= '0'; end if;
  
    case sel is
      when "0000" =>
        result <= cin&a;
        
      when "0001" =>
        result <= cin&b;
        
      when "0010" =>
        result <= cin&(a and b);

      when "0011" =>
        result <= cin&(a or b);

      when "0100" =>
        result <= cin&(not a);

      when "0101" =>
        --result <= a + b + c; -- error in loading or problem in sign extention
        result <= int2bin17(bin2int(a) + bin2int(b) + bin2int(c)); 

      when "0110" =>
        --result <= a - b - c; -- error in loading or problem in sign extention
        result <= int2bin17(bin2int(a) - bin2int(b) - bin2int(c)); 

      when "0111" =>
        result <= cin & word'(a(7 downto 0) * b(7 downto 0));

      when "1000" =>
        result_bit <= (c_bit&a_bit) ROR (shift mod 16);
        for i in 0 to 16 loop
          if result_bit(i) = '1' 
          then result(i) <= '1'; 
          else result(i) <= '0'; 
          end if;
        end loop;

      when "1001" =>
        result_bit <= (c_bit&a_bit) ROL (shift mod 16);
        for i in 0 to 16 loop
          if result_bit(i) = '1' 
          then result(i) <= '1'; 
          else result(i) <= '0'; 
          end if;
        end loop;

      when "1010" =>
        -- result <= cin & (a + b); 
        result <= cin & int2bin16(bin2int(a) + bin2int(b)); 

      when others =>
        result <= (others=>'0'); -- 'Z'
    end case;
  end process;
  
-- output assignment
  aluout <= result (15 downto 0);       
-- carry out
  cout <= result(16);
-- zout assignment
  zout <= '1' when result(15 downto 0) = word'(others => '0') else '0';
end behavioral;
-------------------------------------------------
-- alu test bench:
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity alu_test is
end alu_test;
-------------------------------------------------
architecture test_bench of alu_test is

component alu
  port (a, b: in word; 
        cin : in std_logic;
        sel : in std_logic_vector(3 downto 0);
        aluout: out word;
        zout, cout: out std_logic);
end component;

for all: alu use entity work.alu(behavioral);

-- signal declaration
signal a, b: word; 
signal cin : std_logic;
signal sel : std_logic_vector(3 downto 0);
signal aluout: word;
signal zout, cout: std_logic;

begin
r: alu port map (a, b, cin, sel, aluout, zout, cout);

a <= 
    "0000000000011010",
    "0000000000111111" after 1000 ns,
    "0000000000001111" after 1100 ns,
    "0000000000000011" after 1200 ns,
    "0000000000000000" after 1300 ns,
    "1100000000000000" after 1400 ns;
b <= 
    "1111000000001111",
    "0000000000000010" after 400 ns;

cin <= 
    '0';
    --'0' after 650 ns;
    
sel <= 
    "0000",
    "0001" after 100 ns,
    "0010" after 200 ns,
    "0011" after 300 ns,
    "0100" after 400 ns,
    "0101" after 500 ns,
    "0110" after 600 ns,
    "0111" after 700 ns,
    "1000" after 800 ns,
    "1001" after 1900 ns,
    "1010" after 2000 ns;

end test_bench;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 9: Instruction Cache                        --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- Instruction Cache
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity instruction_cache is
  port (RIM : in std_logic;
        address : in word;
        data: out word);
end instruction_cache;
-------------------------------------------------
architecture behavioral of instruction_cache is
begin
  process (RIM, address)
  variable buf: word_vector(0 to 255):=
  ( 
    "0000000000001111",-- mvi R0, 15;     -- R0 <- 15;        
    "0000010000001010",-- mvi R1, 10;     -- R1 <- 10;   
    "0000100000000101",-- mvi R2, 5;      -- R2 <- 5;
    "0100000100000000",-- and R0, R1;     -- R0 <- 10;          -- R0 <- 0;(5050)(5250)
    "1001111000000011",-- mul R3, R2, 3;  -- R3 <- 15;          -- R3 <- 3;
    "0001011000000000",-- mov R1, R2;     -- R1 <- 5;           -- R1 <- 1;(5450)
    "1000100100000000",-- sub R2, R1;     -- R2 <- 0;           -- R2 <- 0; 
    "1001110100000100",-- mul R3, R1, 4;  -- R3 <- 20;          -- R3 <- 4;
    "0101110100000000",-- orr R3, R1;     -- R3 <- 21;          -- R3 <- 5;
    "0110111100000000",-- not R3, R3;     -- R3 <- -22;         -- R3 <- -6;
    "1101011100100000",-- inc R3, 32;     -- R3 <- 10;C <- 1;   -- R3 <- 26;(5950)
    "1101001100000000",-- srf 1, 1;       -- Z <- 1; C <- 1;    
    "1101101100000000",-- dec R3, 0;      -- R3 <- 9;           -- R3 <- 25;
    "0111110100000000",-- add R3, R1;     -- R3 <- 14;          -- R3 <- 26;
    "1110001100000010",-- ror R3, 2;      -- R3 <- 3; C <- 1;   -- R3 <- 6;(6350)
    "1110001000000010",-- ror R2, 2;      -- R2 <-  ; C <- 0;   -- R2 <- ;
    "1110011100000101",-- rol R3, 5;      -- R3 <- 96;          -- R3 <- 192;
    
    "1100000000000100",-- awp 4;          -- wp <- 4;
    "0000000000001111",-- mvi R0, 15;     -- R0 <- 15;
    "0000010000001010",-- mvi R1, 10;     -- R1 <- 10;   
    "0000100000000101",-- mvi R2, 5;      -- R2 <- 5;
    "0100000100000000",-- and R0, R1;     -- R0 <- 10;
    "1001111000000011",-- mul R3, R2, 3;  -- R3 <- 15;
    "0001011000000000",-- mov R1, R2;     -- R1 <- 5;
    "1000100100000000",-- sub R2, R1;     -- R2 <- 0;
    "1001110100000100",-- mul R3, R1, 4;  -- R3 <- 20;
    "0101110100000000",-- orr R3, R1;     -- R3 <- 21;
    "0110111100000000",-- not R3, R3;     -- R3 <- -22;
    "1101011100100000",-- inc R3, 32;     -- R3 <- 10;C <- 1;
    --"1101001100000000",-- srf 1, 1;       -- Z <- 1; C <- 1;
    "1101101100000000",-- dec R3, 0;      -- R3 <- 9;
    "0111110100000000",-- add R3, R1;     -- R3 <- 14;
    "1110001100000010",-- ror R3, 2;      -- R3 <- 3; C <- 1;
    "1110001000000010",-- ror R2, 2;      -- R2 <-  ; C <- 0;
    "1110011100000101",-- rol R3, 5;      -- R3 <- 96;
    
    "0000100000000000",-- mvi R2, 0;      -- R2 <- 0;
    "0011100100000000",-- sta R2, R1;     -- (0)<- 5;
    "1101011000000001",-- inc R2, 1;      -- R2 <- 1;
    "0011101100000000",-- sta R2, R3;     -- (1)<- 96;
    "1100000000000100",-- awp 4;          -- wp <- 8;
    "0010000000000000",-- lda R0, R0;     -- R0 <-(0)=5;
    "1101011000000001",-- inc R2, 1;      -- R2 <- 1;
    "0010111000000000",-- lda R3, R2;     -- R3 <-(1)=96;
    "1101001000000000",-- srf 1, 0;       -- Z <- 1; C <- 0;    
    "1011110000001111",-- brc 15(4850)

    "1011100000000101",-- brz 5(4950)
    
    
    --"1010000000000111",-- lpc R0,7;       -- R0 <- PC+7=45+7=52;(4950)
    --"0100001100000000",-- and R0, R3;     -- R0 <- 32;
    
    --"1011010000001101",-- jpr 13;         -- pc <- pc+13=47+13=60;
    
    --"1011001000000010",-- jpa R2, 2;      -- pc <- R2+2=3;(4950)
    "1111000000000000",-- nop     
    "1111000000000000",-- nop        
    "1111000000000000",-- nop        
    
    "0100000100000000",-- and R0, R1;     -- R0 <- 10;          -- R0 <- 0;(5050)(5250)
    "1001111000000011",-- mul R3, R2, 3;  -- R3 <- 15;          -- R3 <- 3;
    "0001011000000000",-- mov R1, R2;     -- R1 <- 5;           -- R1 <- 1;(5450)
    "1000100100000000",-- sub R2, R1;     -- R2 <- 0;           -- R2 <- 0; 
    "1001110100000100",-- mul R3, R1, 4;  -- R3 <- 20;          -- R3 <- 4;
    "0101110100000000",-- orr R3, R1;     -- R3 <- 21;          -- R3 <- 5;
    "0110111100000000",-- not R3, R3;     -- R3 <- -22;         -- R3 <- -6;
    "1101011100100000",-- inc R3, 32;     -- R3 <- 10;C <- 1;   -- R3 <- 26;(5950)
    "1101001100000000",-- srf 1, 1;       -- Z <- 1; C <- 1;    
    "1101101100000000",-- dec R3, 0;      -- R3 <- 9;           -- R3 <- 25;
    "0111110100000000",-- add R3, R1;     -- R3 <- 14;          -- R3 <- 26;        -- line 60
    "1110001100000010",-- ror R3, 2;      -- R3 <- 3; C <- 1;   -- R3 <- 6;(6350)
    "1110001000000010",-- ror R2, 2;      -- R2 <-  ; C <- 0;   -- R2 <- ;
    "1110011100000101",-- rol R3, 5;      -- R3 <- 96;          -- R3 <- 192;

    "0000000000000000",              
    
    others => (others => '0')
  );
  begin
    if RIM='1' 
    then data <= buf(bin2int(address(7 downto 0))); 
    else data <= (others => '0');
    end if;
  end process;
end behavioral;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 10: Data Cache                              --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- Data Cache
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity data_cache is
  port (clk, WDM : in std_logic;
        address : in word;
        write_data: in word;
        read_data: out word);
end data_cache;
-------------------------------------------------
architecture behavioral of data_cache is
begin
  process (clk, address)
  variable buf: word_vector(0 to 63):=
  ( "0000000000000000",
    "0000000000000000",   
    "0000000000000000",
    others => (others => '0')
  );
  begin
    if (clk='0' and clk'event) then
    if WDM='1' then  
      buf(bin2int(address(5 downto 0))) := write_data; 
    end if;
    end if;
    
    read_data <= buf(bin2int(address(5 downto 0))); 
  end process;
end behavioral;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 11: Branch Unit                             --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- Branch Unit
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity branch is
  port    (
           carry, zero: in std_logic;
           jpa, brz, brc: in std_logic;
           sel: out std_logic_vector(1 downto 0)
          );
end branch;
-------------------------------------------------
architecture combinational of branch is

begin
  process (carry, zero, jpa, brz, brc)
  begin

    if (brz = '1' and zero = '1') or
       (brc = '1' and carry= '1') 
    then sel <= "10";
    elsif jpa = '1' then sel <= "11";
    else sel <= "00";
    end if;

  end process;    
end combinational;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 12: Controller                              --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- Controller
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity controller is
  port    (
           reset: in std_logic;
           opcode: in std_logic_vector(3 downto 0);
           D: in std_logic_vector(1 downto 0);
           sel: in std_logic_vector(1 downto 0);

           
           next_pc_sel: out std_logic_vector(1 downto 0);
           RIM: out std_logic;
           WP_sel: out std_logic;
           adder_input_sel: out std_logic;
           
           EXE: out std_logic_vector(12 downto 0);
           MEM: out std_logic;
           WB: out std_logic_vector(3 downto 0));
end controller;
-------------------------------------------------
architecture combinational of controller is

-- signal declaration
signal alu_op: std_logic_vector(3 downto 0);
signal alu_input_sel: std_logic;
signal C_sel: std_logic_vector(1 downto 0);
signal Z_sel: std_logic_vector(1 downto 0);
signal jpa, jpr, brz, brc: std_logic;

signal WDM: std_logic;

signal WRF: std_logic;
signal write_data_sel: std_logic_vector(1 downto 0);
signal dest_sel: std_logic;

begin
  EXE <= alu_op & alu_input_sel & C_sel & Z_sel &
         jpa & jpr & brz & brc;
  MEM <= WDM;
  WB  <= WRF & write_data_sel & dest_sel;

  process (reset, opcode, D, sel)
  begin
    
    next_pc_sel     <= "00";
    WP_sel          <= '0'; 
    adder_input_sel <= '0';

    alu_op        <= "0000";
    alu_input_sel <= '0';
    C_sel <= "00";
    Z_sel <= "00";
    jpa   <= '0';
    jpr   <= '0';
    brz   <= '0';
    brc   <= '0';

    WDM <= '0';

    WRF <= '0';
    write_data_sel <= "00";
    dest_sel        <= '0';

    if reset/='1' then    
      case opcode is
        when "0000" => -- mvi
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0001";-- put B on output
          alu_input_sel <= '1';
          C_sel <= "00";
          Z_sel <= "00";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "0001" => -- mvr
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0000";-- put A on output
          alu_input_sel <= '0'; -- dont care
          C_sel <= "00";
          Z_sel <= "00";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "0010" => -- lda
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0000";-- put A on output
          alu_input_sel <= '0'; -- dont care
          C_sel <= "00";
          Z_sel <= "00";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "01";
          dest_sel        <= '0';

        when "0011" => -- sta
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0001";-- put B on output
          alu_input_sel <= '0';             
          C_sel <= "00";
          Z_sel <= "00";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '1';

          WRF <= '0';
          write_data_sel <= "00"; -- dont care
          dest_sel        <= '0'; -- dont care

        when "0100" => -- and
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0010";-- &
          alu_input_sel <= '0';
          C_sel <= "00";
          Z_sel <= "01";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "0101" => -- orr
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0011";-- |
          alu_input_sel <= '0';
          C_sel <= "00";
          Z_sel <= "01";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "0110" => -- not
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0100";-- ^
          alu_input_sel <= '0';-- dont care
          C_sel <= "00";
          Z_sel <= "01";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "0111" => -- add
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0101";-- +
          alu_input_sel <= '0';
          C_sel <= "01";
          Z_sel <= "01";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "1000" => -- sub
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0110";-- -
          alu_input_sel <= '0';
          C_sel <= "01";
          Z_sel <= "01";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "1001" => -- mul
          next_pc_sel     <= "00";
          WP_sel          <= '0'; 
          adder_input_sel <= '0'; -- dont care

          alu_op        <= "0111";-- *
          alu_input_sel <= '1';
          C_sel <= "00";
          Z_sel <= "01";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '1';
          write_data_sel <= "10";
          dest_sel        <= '0';

        when "1010" =>
          case D is
            when "00" => -- lpc
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '1'; 

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '0'; -- dont care
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '1';
              write_data_sel <= "00";
              dest_sel        <= '1';

            when others => null;

          end case;

        when "1011" =>
          case D is
            when "00" => -- jpa
              next_pc_sel     <= "00"; -- dont care
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "1010"; -- + without carry
              alu_input_sel <= '1';
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '1';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when "01" => -- jpr
              next_pc_sel     <= "01";
              WP_sel          <= '0'; 
              adder_input_sel <= '1'; 

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '1'; -- dont care
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '0';
              jpr   <= '1';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when "10" => -- brz
              next_pc_sel     <= "00"; -- dont care
              WP_sel          <= '0'; 
              adder_input_sel <= '1'; 

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '1'; -- dont care
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '1';
              brc   <= '0';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when "11" => -- brc
              next_pc_sel     <= "00"; -- dont care
              WP_sel          <= '0'; 
              adder_input_sel <= '1'; 

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '1'; -- dont care
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '1';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when others => null;

          end case;

        when "1100" => -- awp
          next_pc_sel     <= "00";
          WP_sel          <= '1'; 
          adder_input_sel <= '0';

          alu_op        <= "0000"; -- dont care
          alu_input_sel <= '0'; -- dont care
          C_sel <= "00";
          Z_sel <= "00";
          jpa   <= '0';
          jpr   <= '0';
          brz   <= '0';
          brc   <= '0';

          WDM <= '0';

          WRF <= '0';
          write_data_sel <= "00"; -- dont care 
          dest_sel        <= '0'; -- dont care



        when "1101" =>
          case D is
            when "00" => -- SRF
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '0'; -- dont care
              C_sel <= "10";
              Z_sel <= "10";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when "01" => -- INC
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "0101"; -- +
              alu_input_sel <= '1'; 
              C_sel <= "01";
              Z_sel <= "01";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '1';
              write_data_sel <= "10";
              dest_sel        <= '1'; 

            when "10" => -- DEC
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "0110"; -- -
              alu_input_sel <= '1'; 
              C_sel <= "01";
              Z_sel <= "01";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '1';
              write_data_sel <= "10";
              dest_sel        <= '1'; 

            when others => null;

          end case;

        when "1110" =>
          case D is
            when "00" => -- ROR
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "1000"; -- ROR
              alu_input_sel <= '1'; 
              C_sel <= "01";
              Z_sel <= "01";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '1';
              write_data_sel <= "10";
              dest_sel        <= '1'; 

            when "01" => -- ROL
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "1001"; -- ROL
              alu_input_sel <= '1'; 
              C_sel <= "01";
              Z_sel <= "01";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '1';
              write_data_sel <= "10";
              dest_sel        <= '1'; 

            when others => null;

          end case;


        when "1111" =>
          case D is
            when "00" => -- nop
              next_pc_sel     <= "00";
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '0'; -- dont care
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when "01" => -- hlt
              next_pc_sel     <= "00";-- dont care
              RIM             <= '0'; -- this process needs external reset!
              WP_sel          <= '0'; 
              adder_input_sel <= '0'; -- dont care

              alu_op        <= "0000"; -- dont care
              alu_input_sel <= '0'; -- dont care
              C_sel <= "00";
              Z_sel <= "00";
              jpa   <= '0';
              jpr   <= '0';
              brz   <= '0';
              brc   <= '0';

              WDM <= '0';

              WRF <= '0';
              write_data_sel <= "00"; -- dont care
              dest_sel        <= '0'; -- dont care

            when others => null;

          end case;

        when others => null;

      end case;
      if sel/="00" then next_pc_sel <= sel; end if;
    else -- if reset = '1' then
      RIM <= '1';
    end if;
  end process;    
end combinational;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 13: Forwarding Unit                         --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- Forwarding Unit
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use work.payeh.all;
-------------------------------------------------
entity forwarding is
  port    (
           reset: in std_logic;
           WRF: in std_logic;
           opcode, opcode_EXE, opcode_MEM, opcode_WB: in std_logic_vector(3 downto 0);
           WP, WP_EXE, WP_MEM, WP_WB: in std_logic_vector(5 downto 0);
           S, S_EXE, S_MEM, S_WB: in std_logic_vector(1 downto 0);
           D, D_EXE, D_MEM, D_WB: in std_logic_vector(1 downto 0);
           Dest: in std_logic_vector(1 downto 0);
           sel: in std_logic_vector(1 downto 0);
           
           F_ID1_sel,F_ID2_sel: out std_logic;
           F_EXE1_sel,F_EXE2_sel: out std_logic_vector(1 downto 0);
           F_MEM1_sel,F_MEM2_sel: out std_logic;
           WPC, W_IF_ID, W_ID_EXE, W_EXE_MEM, W_MEM_WB: out std_logic
          );
end forwarding;
-------------------------------------------------
architecture combinational of forwarding is

signal load_lock: std_logic := '0';
signal branch1_lock: std_logic := '0';
signal branch2_lock: std_logic_vector(1 downto 0) := "00";

constant op_mvi: std_logic_vector(3 downto 0) := "0000";
constant op_mvr: std_logic_vector(3 downto 0) := "0001";

constant op_lda: std_logic_vector(3 downto 0) := "0010";
constant op_sta: std_logic_vector(3 downto 0) := "0011";
 
constant op_and: std_logic_vector(3 downto 0) := "0100";
constant op_orr: std_logic_vector(3 downto 0) := "0101";
constant op_not: std_logic_vector(3 downto 0) := "0110";
constant op_add: std_logic_vector(3 downto 0) := "0111";
constant op_sub: std_logic_vector(3 downto 0) := "1000";
constant op_mul: std_logic_vector(3 downto 0) := "1001";

constant op_lpc: std_logic_vector(3 downto 0) := "1010";

constant op_inc: std_logic_vector(3 downto 0) := "1101";
constant op_dec: std_logic_vector(3 downto 0) := "1101";
constant op_ror: std_logic_vector(3 downto 0) := "1110";
constant op_rol: std_logic_vector(3 downto 0) := "1110";

constant op_jpa: std_logic_vector(3 downto 0) := "1011";

constant  d_lpc: std_logic_vector(1 downto 0) := "00";
constant  d_inc: std_logic_vector(1 downto 0) := "01";
constant  d_dec: std_logic_vector(1 downto 0) := "10";
constant  d_ror: std_logic_vector(1 downto 0) := "00";
constant  d_rol: std_logic_vector(1 downto 0) := "01";
constant  d_jpa: std_logic_vector(1 downto 0) := "00";

begin
  process (
           reset,
           WRF,
           opcode, opcode_EXE, opcode_MEM, opcode_WB,
           WP, WP_EXE, WP_MEM, WP_WB,
           S, S_EXE, S_MEM, S_WB,
           D, D_EXE, D_MEM, D_WB,
           Dest,
           sel
          )

  begin
    
    F_ID1_sel  <= '0';
    F_ID2_sel  <= '0';
    F_EXE1_sel <= "00";
    F_EXE2_sel <= "00";
    F_MEM1_sel <= '0';
    F_MEM2_sel <= '0';
    
    WPC        <= '1';
    W_IF_ID    <= '1';
    W_ID_EXE   <= '1';
    W_EXE_MEM  <= '1';
    W_MEM_WB   <= '1';


    if reset/='1' then  
    -- inactivation
    --if reset='U' then  
      --------------------
      if (WP+S = WP_WB+Dest) and (WRF = '1') then F_ID1_sel <= '1'; else F_ID1_sel <= '0'; end if;
      --------------------
      if (WP+D = WP_WB+Dest) and (WRF = '1') then F_ID2_sel <= '1'; else F_ID2_sel <= '0'; end if;
      --------------------
      if 
      ((opcode_MEM = op_mvi or
        opcode_MEM = op_mvr or
        opcode_MEM = op_and or
        opcode_MEM = op_orr or
        opcode_MEM = op_not or
        opcode_MEM = op_add or
        opcode_MEM = op_sub or
        opcode_MEM = op_mul) and
        (WP_EXE+S_EXE = WP_MEM+D_MEM)) or

      (((opcode_MEM = op_inc and D_MEM = d_inc) or
        (opcode_MEM = op_dec and D_MEM = d_dec) or
        (opcode_MEM = op_ror and D_MEM = d_ror) or
        (opcode_MEM = op_rol and D_MEM = d_rol)) and
        (WP_EXE+S_EXE = WP_MEM+S_MEM))
      then F_EXE1_sel <= "01";
      elsif 
      ((opcode_MEM = op_lpc and D_MEM = d_lpc) and
        (WP_EXE+S_EXE = WP_MEM+S_MEM))
      then F_EXE1_sel <= "11";
      elsif
      ((opcode_WB  = op_mvi or
        opcode_WB  = op_mvr or
        opcode_WB  = op_and or
        opcode_WB  = op_orr or
        opcode_WB  = op_not or
        opcode_WB  = op_add or
        opcode_WB  = op_sub or
        opcode_WB  = op_mul or
        
        (opcode_WB  = op_inc and D_WB = d_inc) or
        (opcode_WB  = op_dec and D_WB = d_dec) or
        (opcode_WB  = op_ror and D_WB = d_ror) or
        (opcode_WB  = op_rol and D_WB = d_rol) or
        
        (opcode_WB  = op_lpc and D_WB = d_lpc) or
        
        opcode_WB  = op_lda) and
        (WP_EXE+S_EXE = WP_WB+Dest))

      then F_EXE1_sel <= "10";
      else F_EXE1_sel <= "00";
      end if;
      --------------------
      if 
      ((opcode_MEM = op_mvi or
        opcode_MEM = op_mvr or
        opcode_MEM = op_and or
        opcode_MEM = op_orr or
        opcode_MEM = op_not or
        opcode_MEM = op_add or
        opcode_MEM = op_sub or
        opcode_MEM = op_mul) and
        (WP_EXE+D_EXE = WP_MEM+D_MEM)) or

      (((opcode_MEM = op_inc and D_MEM = d_inc) or
        (opcode_MEM = op_dec and D_MEM = d_dec) or
        (opcode_MEM = op_ror and D_MEM = d_ror) or
        (opcode_MEM = op_rol and D_MEM = d_rol)) and
        (WP_EXE+D_EXE = WP_MEM+S_MEM))
      then F_EXE2_sel <= "01";
      elsif 
      ((opcode_MEM = op_lpc and D_MEM = d_lpc) and
        (WP_EXE+D_EXE = WP_MEM+S_MEM))
      then F_EXE2_sel <= "11";
      elsif
      ((opcode_WB  = op_mvi or
        opcode_WB  = op_mvr or
        opcode_WB  = op_and or
        opcode_WB  = op_orr or
        opcode_WB  = op_not or
        opcode_WB  = op_add or
        opcode_WB  = op_sub or
        opcode_WB  = op_mul or
        
        (opcode_WB  = op_inc and D_WB = d_inc) or
        (opcode_WB  = op_dec and D_WB = d_dec) or
        (opcode_WB  = op_ror and D_WB = d_ror) or
        (opcode_WB  = op_rol and D_WB = d_rol) or
        
        (opcode_WB  = op_lpc and D_WB = d_lpc) or
        
        opcode_WB  = op_lda) and
        (WP_EXE+D_EXE = WP_WB+Dest))

      then F_EXE2_sel <= "10";
      else F_EXE2_sel <= "00";
      end if;
      --------------------
      if
      ((opcode_WB  = op_mvi or
        opcode_WB  = op_mvr or
        opcode_WB  = op_and or
        opcode_WB  = op_orr or
        opcode_WB  = op_not or
        opcode_WB  = op_add or
        opcode_WB  = op_sub or
        opcode_WB  = op_mul or
        
        (opcode_WB  = op_inc and D_WB = d_inc) or
        (opcode_WB  = op_dec and D_WB = d_dec) or
        (opcode_WB  = op_ror and D_WB = d_ror) or
        (opcode_WB  = op_rol and D_WB = d_rol) or
        
        (opcode_WB  = op_lpc and D_WB = d_lpc) or
        
        opcode_WB  = op_lda) and
        
        (((opcode_MEM = op_lda) and (WP_MEM+S_MEM = WP_WB+Dest)) or
         ((opcode_MEM = op_sta) and (WP_MEM+D_MEM = WP_WB+Dest)) ))

      then F_MEM1_sel <= '1';
      else F_MEM1_sel <= '0';
      end if;
      --------------------
      if
      ((opcode_WB  = op_mvi or
        opcode_WB  = op_mvr or
        opcode_WB  = op_and or
        opcode_WB  = op_orr or
        opcode_WB  = op_not or
        opcode_WB  = op_add or
        opcode_WB  = op_sub or
        opcode_WB  = op_mul or
        
        (opcode_WB  = op_inc and D_WB = d_inc) or
        (opcode_WB  = op_dec and D_WB = d_dec) or
        (opcode_WB  = op_ror and D_WB = d_ror) or
        (opcode_WB  = op_rol and D_WB = d_rol) or
        
        (opcode_WB  = op_lpc and D_WB = d_lpc) or
        
        opcode_WB  = op_lda) and
        
        (opcode_MEM = op_sta) and (WP_MEM+S_MEM = WP_WB+Dest) )

      then F_MEM2_sel <= '1';
      else F_MEM2_sel <= '0';
      end if;
      --------------------
--      -- stall for load
--      if 
--       (opcode_MEM = op_lda and
--  
--     (((--opcode_EXE = op_mvi or
--        --opcode_EXE = op_mvr or
--        opcode_EXE = op_and or
--        opcode_EXE = op_orr or
--        --opcode_EXE = op_not or
--        opcode_EXE = op_add or
--        opcode_EXE = op_sub --or
--        --opcode_EXE = op_mul
--        ) and
--        (WP_MEM+D_MEM = WP_EXE+D_EXE)) or
---- new begin     
--      ((opcode_EXE = op_mvr or
--        opcode_EXE = op_and or
--        opcode_EXE = op_orr or
--        opcode_EXE = op_not or
--        opcode_EXE = op_add or
--        opcode_EXE = op_sub or
--        opcode_EXE = op_mul or
--        (opcode_EXE = op_jpa and D_EXE = d_jpa)) and
--        (WP_MEM+D_MEM = WP_EXE+S_EXE)) or
---- new end.
--               
--      (((opcode_EXE = op_inc and D_EXE = d_inc) or
--        (opcode_EXE = op_dec and D_EXE = d_dec) or
--        (opcode_EXE = op_ror and D_EXE = d_ror) or
--        (opcode_EXE = op_rol and D_EXE = d_rol) or
--               
--        (opcode_EXE = op_jpa and D_EXE = d_jpa)) and
--        (WP_MEM+D_MEM = WP_EXE+S_EXE)))) 
--        and (load_lock = '0')
--        
--      then 
--        WPC        <= '0';
--        W_IF_ID    <= '0';
--        W_ID_EXE   <= '0';
--        W_EXE_MEM  <= '0';
--        W_MEM_WB   <= '1'; 
--        load_lock  <= '1';
--      else
--        WPC        <= '1';
--        W_IF_ID    <= '1';
--        W_ID_EXE   <= '1';
--        W_EXE_MEM  <= '1';
--        W_MEM_WB   <= '1';
--        load_lock  <= '0';
--      end if;
--      
--      --------------------
--      -- stall for branches
--      if (sel = "01") and (branch1_lock = '0') then
--        W_IF_ID    <= '0';
--        branch1_lock <= '1';
--      elsif (branch1_lock = '1') then
--        W_IF_ID    <= '1';
--        branch1_lock <= '0';
--      end if;
--      
--      if (sel = "10" or sel = "11") and (branch2_lock = "00") then
--        W_IF_ID    <= '0';
--        W_ID_EXE   <= '0';
--        branch2_lock <= "10";
--      elsif (branch2_lock = "10") then
--        W_IF_ID    <= '1';
--        W_ID_EXE   <= '0';
--        branch2_lock <= "01";
--      elsif (branch2_lock = "01") then
--        W_IF_ID    <= '1';
--        W_ID_EXE   <= '1';
--        branch2_lock <= "00";
--      end if;
--      -- some IF, one after the other one, may cause problem!!!!!!!!!
      
    end if;
  end process;    
end combinational;
-------------------------------------------------


-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 14: Data path                               --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- Datapath
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use work.payeh.all;
-------------------------------------------------
entity datapath is
  port    (clk, reset: in  std_logic);
end datapath;
-------------------------------------------------
architecture pipeline of datapath is

component mux_2_1 
  port (d0, d1: in  std_logic_vector; 
        sel:    in  std_logic; 
        q:      out std_logic_vector);
end component;

component mux_4_1 
  port (d0, d1, d2, d3: in  std_logic_vector; 
        sel:    in  std_logic_vector(1 downto 0); 
        q:      out std_logic_vector);
end component;

component mux4_1
  port (d0, d1, d2, d3: in  std_logic; 
        sel:    in  std_logic_vector(1 downto 0); 
        q:      out std_logic);
end component;

component reg 
  port (clk, reset, wrt: in std_logic;
        d: in  std_logic_vector; 
        q: out std_logic_vector);
end component;

component regfile 
  port (clk, reset, write_en: in std_logic;
        read_wp, write_wp: in std_logic_vector(5 downto 0);
        read_adr1, read_adr2, write_adr: in  std_logic_vector(1 downto 0); 
        write_data: in word;
        read_data1, read_data2: out word);
end component;

component alu 
  port (a, b: in word; 
        cin : in std_logic;
        sel : in std_logic_vector(3 downto 0);
        aluout: out word;
        zout, cout: out std_logic);
end component;

component adder 
  port (a, b: in word; 
        a_plus_b: out word);
end component;

component inc
  port (a: in word; 
        a_plus_1: out word);
end component;

component instruction_cache
  port (RIM : in std_logic;
        address : in word;
        data: out word);
end component;

component data_cache 
  port (clk, WDM : in std_logic;
        address : in word;
        write_data: in word;
        read_data: out word);
end component;

component controller 
  port (
        reset: in std_logic;
        opcode: in std_logic_vector(3 downto 0);
        D: in std_logic_vector(1 downto 0);
        sel: in std_logic_vector(1 downto 0);
        
        next_pc_sel: out std_logic_vector(1 downto 0);
        RIM: out std_logic;
        WP_sel: out std_logic;
        adder_input_sel: out std_logic;
        
        EXE: out std_logic_vector(12 downto 0);
        MEM: out std_logic;
        WB: out std_logic_vector(3 downto 0)
       );
end component;

component forwarding 
  port (
        reset: in std_logic;
        WRF: in std_logic;
        opcode, opcode_EXE, opcode_MEM, opcode_WB: in std_logic_vector(3 downto 0);
        WP, WP_EXE, WP_MEM, WP_WB: in std_logic_vector(5 downto 0);
        S, S_EXE, S_MEM, S_WB: in std_logic_vector(1 downto 0);
        D, D_EXE, D_MEM, D_WB: in std_logic_vector(1 downto 0);
        Dest: in std_logic_vector(1 downto 0);
        sel: in std_logic_vector(1 downto 0);

        
        F_ID1_sel,F_ID2_sel: out std_logic;
        F_EXE1_sel,F_EXE2_sel: out std_logic_vector(1 downto 0);
        F_MEM1_sel,F_MEM2_sel: out std_logic;
        WPC, W_IF_ID, W_ID_EXE, W_EXE_MEM, W_MEM_WB: out std_logic
       );
end component;

component branch
  port (
        carry, zero: in std_logic;
        jpa, brz, brc: in std_logic;
        sel: out std_logic_vector(1 downto 0)
       );
end component;

-- signal declaration
-- IF
signal IF_ID_in, IF_ID_out: std_logic_vector (37 downto 0);

signal pc_plus_1, pc_plus_I, Rs_plus_I, next_pc, pc_out,
       IR: word;
       
signal WP_new, WP_in: std_logic_vector (5 downto 0);

signal next_pc_sel: std_logic_vector (1 downto 0);
signal RIM, WP_sel: std_logic;
signal WPC, W_IF_ID: std_logic;

-- ID
-- ID -- control
signal ctrl_exe: std_logic_vector (12 downto 0);
signal ctrl_mem: std_logic;
signal ctrl_wb : std_logic_vector (3 downto 0);

signal ID_EXE_in, ID_EXE_out: std_logic_vector (95 downto 0);

signal pc_plus_1_ID, IR_ID,
       S_data, D_data, S_data_ID, D_data_ID, write_data,
       WP_zero_extended, I_sign_extended,
       adder_input1, adder_output: word;

signal I: std_logic_vector (7 downto 0);

signal WP: std_logic_vector (5 downto 0);

signal opcode: std_logic_vector (3 downto 0);
signal S, D, dest: std_logic_vector (1 downto 0);

signal WRF, adder_input_sel: std_logic;
signal F_ID1_sel, F_ID2_sel: std_logic;
signal W_ID_EXE: std_logic;

-- EXE
-- EXE -- control
signal ctrl_mem_EXE: std_logic;
signal ctrl_wb_EXE: std_logic_vector (3 downto 0);

signal EXE_MEM_in, EXE_MEM_out: std_logic_vector (68 downto 0);
signal pc_plus_I_EXE, S_data_EXE, D_data_EXE, S_data_EXE_f, D_data_EXE_f,
       I_EXE, alu_input2, alu_out: word;
signal WP_EXE: std_logic_vector (5 downto 0);
signal opcode_EXE: std_logic_vector(3 downto 0);
signal alu_op: std_logic_vector (3 downto 0);
signal C_sel, Z_sel: std_logic_vector (1 downto 0);
signal D_EXE, S_EXE: std_logic_vector(1 downto 0);
signal F_EXE1_sel, F_EXE2_sel: std_logic_vector(1 downto 0);

signal alu_input_sel, cin, zin, cout, zout, 
       C_set, Z_set, zero_flag, carry_flag,
       jpa, jpr, brz, brc: std_logic;

signal W_EXE_MEM: std_logic;
       

-- MEM
-- MEM -- control
signal ctrl_wb_MEM: std_logic_vector (3 downto 0);

signal MEM_WB_in, MEM_WB_out: std_logic_vector (65 downto 0);
signal pc_plus_I_MEM, alu_out_MEM, mem_address, mem_address_f,
       mem_data, mem_data_f, read_data: word;

signal WP_MEM        : std_logic_vector(5 downto 0);
signal opcode_MEM    : std_logic_vector(3 downto 0);
signal D_MEM, S_MEM  : std_logic_vector(1 downto 0);

signal WDM: std_logic;
signal F_MEM1_sel, F_MEM2_sel: std_logic;
signal W_MEM_WB: std_logic;

-- WB
signal pc_plus_I_WB, read_data_WB, alu_out_WB: word;
signal WP_WB         : std_logic_vector(5 downto 0);
signal opcode_WB     : std_logic_vector(3 downto 0);
signal D_WB, S_WB    : std_logic_vector(1 downto 0);
signal write_data_sel: std_logic_vector(1 downto 0);
signal dest_sel      : std_logic;

--
signal branch_sel: std_logic_vector(1 downto 0);


begin

  -- many signals are alias signals!
  -----------------------------------------------
  -- IF
  pc_plus_I <= adder_output;
  
  next_pc_mux: mux_4_1 port map(pc_plus_1, pc_plus_I, pc_plus_I_EXE, Rs_plus_I, 
                               next_pc_sel,
                               next_pc);
  
  Rs_plus_I <= alu_out;
  pc: reg port map(clk, reset, WPC, next_pc, pc_out);
  
  instr_cache: instruction_cache port map(RIM, pc_out, IR);
  
  pc_inc: inc port map(pc_out, pc_plus_1);
  
  WP_new <= adder_output(5 downto 0);
  
  WP_mux: mux_2_1 port map (WP, WP_new, WP_sel, WP_in);
  
  IF_ID_in <= pc_plus_1 & WP_in & IR;
  IF_ID: reg port map(clk, reset, W_IF_ID, IF_ID_in, IF_ID_out);
  
  -----------------------------------------------
  -- ID
  pc_plus_1_ID <= IF_ID_out(37 downto 22);
  WP           <= IF_ID_out(21 downto 16);
  IR_ID        <= IF_ID_out(15 downto  0);
  
  Opcode <= IR_ID(15 downto 12);
  D      <= IR_ID(11 downto 10);
  S      <= IR_ID( 9 downto  8);
  I      <= IR_ID( 7 downto  0);
  
  register_file: regfile port map(clk, reset, WRF, WP, WP_WB, 
                                  S, D, dest,
                                  write_data,
                                  S_data, D_data);
                                  
 
  WP_zero_extended <= ("0000000000" & WP);
  I_sign_extended <= byte'(others=>I(7)) & I;
  
  adder_input_mux: mux_2_1 port map(WP_zero_extended, pc_plus_1_ID,
                                    adder_input_sel, adder_input1);
                                    
  adder16: adder port map(adder_input1, I_sign_extended, adder_output);
  
  forward_ID1: mux_2_1 port map(S_data, write_data, F_ID1_sel, S_data_ID);
  forward_ID2: mux_2_1 port map(D_data, write_data, F_ID2_sel, D_data_ID);
  
  ID_EXE_in <= ctrl_exe & ctrl_mem & ctrl_wb & 
               pc_plus_I & S_data_ID & D_data_ID & 
               I_sign_extended & WP & D & S & opcode;
               
  ID_EXE: reg port map(clk, reset, W_ID_EXE, ID_EXE_in, ID_EXE_out);
  
  -----------------------------------------------
  -- EXE
  alu_op        <= ID_EXE_out(95 downto 92);
  alu_input_sel <= ID_EXE_out(91);
  C_sel         <= ID_EXE_out(90 downto 89);
  Z_sel         <= ID_EXE_out(88 downto 87);
  jpa           <= ID_EXE_out(86);
  jpr           <= ID_EXE_out(85);
  brz           <= ID_EXE_out(84);
  brc           <= ID_EXE_out(83);
  
  ctrl_mem_EXE  <= ID_EXE_out(82);
  ctrl_wb_EXE   <= ID_EXE_out(81 downto 78);

  pc_plus_I_EXE <= ID_EXE_out(77 downto 62);
  S_data_EXE    <= ID_EXE_out(61 downto 46);
  D_data_EXE    <= ID_EXE_out(45 downto 30);
  I_EXE         <= ID_EXE_out(29 downto 14);
  
  WP_EXE        <= ID_EXE_out(13 downto  8);
  D_EXE         <= ID_EXE_out( 7 downto  6);
  S_EXE         <= ID_EXE_out( 5 downto  4);
  opcode_EXE    <= ID_EXE_out( 3 downto  0);
   
  forward_EXE1: mux_4_1 port map(S_data_EXE, mem_address, write_data, pc_plus_I_MEM, 
                                 F_EXE1_sel, S_data_EXE_f);
  forward_EXE2: mux_4_1 port map(D_data_EXE, mem_address, write_data, pc_plus_I_MEM,
                                 F_EXE2_sel, D_data_EXE_f);
  
  alu_input_mux: mux_2_1 port map(D_data_EXE_f, I_EXE, alu_input_sel,
                                 alu_input2);

  alu_unit: alu port map(S_data_EXE_f, alu_input2, cin, alu_op,
                         alu_out, zout, cout);

  C_mux: mux4_1 port map(cin, cout, C_set, 'Z',
                          C_sel, carry_flag);
  Z_mux: mux4_1 port map(zin, zout, Z_set, 'Z',
                          Z_sel, zero_flag);
  
  Z_set <= S_EXE(1);
  C_set <= S_EXE(0);

  EXE_MEM_in <= ctrl_mem_EXE & ctrl_wb_EXE &
                pc_plus_I_EXE & carry_flag & zero_flag &
                alu_out & S_data_EXE_f & 
                WP_EXE & D_EXE & S_EXE & opcode_EXE;
  
  EXE_MEM: reg port map(clk, reset, W_EXE_MEM, EXE_MEM_in, EXE_MEM_out);
  
  -----------------------------------------------
  -- MEM
  WDM           <= EXE_MEM_out(68);
  
  ctrl_wb_MEM   <= EXE_MEM_out(67 downto 64);
  pc_plus_I_MEM <= EXE_MEM_out(63 downto 48);
  cin           <= EXE_MEM_out(47);
  zin           <= EXE_MEM_out(46);
  alu_out_MEM   <= EXE_MEM_out(45 downto 30);
  mem_data      <= EXE_MEM_out(29 downto 14);

  WP_MEM        <= EXE_MEM_out(13 downto  8);
  D_MEM         <= EXE_MEM_out( 7 downto  6);
  S_MEM         <= EXE_MEM_out( 5 downto  4);
  opcode_MEM    <= EXE_MEM_out( 3 downto  0);
  
  mem_address <= alu_out_MEM;

  forward_MEM1: mux_2_1 port map(mem_address, write_data, F_MEM1_sel, mem_address_f);
  forward_MEM2: mux_2_1 port map(mem_data, write_data, F_MEM2_sel, mem_data_f);
  
  data_cache_unit: data_cache port map(clk, WDM,
                                       mem_address_f, mem_data_f,
                                       read_data);
  
  MEM_WB_in <= ctrl_wb_MEM & 
               pc_plus_I_MEM & read_data & alu_out_MEM &
               WP_MEM & D_MEM & S_MEM & opcode_MEM;
  
  MEM_WB: reg port map(clk, reset, W_MEM_WB, MEM_WB_in, MEM_WB_out);
  
  -----------------------------------------------
  -- WB
  WRF            <= MEM_WB_out(65);
  write_data_sel <= MEM_WB_out(64 downto 63);
  dest_sel       <= MEM_WB_out(62);
  
  pc_plus_I_WB   <= MEM_WB_out(61 downto 46);
  read_data_WB   <= MEM_WB_out(45 downto 30);
  alu_out_WB     <= MEM_WB_out(29 downto 14);
  
  WP_WB          <= MEM_WB_out(13 downto  8);
  D_WB           <= MEM_WB_out( 7 downto  6);
  S_WB           <= MEM_WB_out( 5 downto  4);
  opcode_WB      <= MEM_WB_out( 3 downto  0);
  
  write_data_mux: mux_4_1 port map(pc_plus_I_WB, read_data_WB,
                                   alu_out_WB, "ZZZZZZZZZZZZZZZZ",
                                   write_data_sel,
                                   write_data);

  dest_mux: mux_2_1 port map(D_WB, S_WB, dest_sel, dest);                                 

  -----------------------------------------------
  -- controller                                   
  
  control_unit: controller 
    port map
    (
        reset, opcode, D, branch_sel, 
        next_pc_sel, RIM, WP_sel, adder_input_sel,
        ctrl_exe, ctrl_mem, ctrl_wb
    );

  -----------------------------------------------
  -- Foewardibng Unit
  forward_unit: forwarding
    port map
    (
        reset, 
        WRF,
        opcode, opcode_EXE, opcode_MEM, opcode_WB,
        WP, WP_EXE, WP_MEM, WP_WB,
        S, S_EXE, S_MEM, S_WB,
        D, D_EXE, D_MEM, D_WB,
        Dest,
        next_pc_sel,
        
        F_ID1_sel,F_ID2_sel,
        F_EXE1_sel,F_EXE2_sel,
        F_MEM1_sel,F_MEM2_sel,
        WPC, W_IF_ID, W_ID_EXE, W_EXE_MEM, W_MEM_WB   
    );
    
  -----------------------------------------------
  -- Branch Unit
  branch_unit: branch
    port map
    (
        cin, zin,
        jpa, brz, brc,
        branch_sel
    );
    
end pipeline;
-------------------------------------------------

-----------------------------------------------------------
--                         PAYEH                         --
--      (Pipelined Architecture Yet Enough Hardware)     --
--                   (Pipelined sAYEH)                   --
--                                                       --
--      VHDL Implementation                              --
--      File 15: system                                  --
--                                                       --
--  Saeed Shamshiri                                      --
--  Student Number: 81 01 81 082                         --
--  eMail: saeedshamshiri@yahoo.com                      --
-----------------------------------------------------------

-- system
-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity System is 
end System;
-------------------------------------------------
architecture structural of System is

component datapath
  port    (clk, reset: in  std_logic);
end component;

signal  Clk, reset: std_logic := '0';
begin
CPU: datapath port map (Clk, reset);

Clk   <= not Clk after 50 ns when now<15 us else Clk;

reset <= 
  '1', 
  '0' after 100 ns, 
  '1' after 8000 ns, 
  '0' after 8100 ns;

end structural;
-------------------------------------------------
